# -*- coding: utf-8 -*-

# require 'resolv-replace'

module Net2ch

  class AboneExcepton < StandardError ; end  # for get
  @@agent = "Monazilla/1.00"

  def Net2ch.get(url, last = false, bytes = false, gzip = GZIP)
    header = {}
    header['User-Agent']= @@agent
    header['If-Modified-Since']= last if last
    # header['Accept-Encoding']= 'gzip' if gzip
    header['Range']= bytes if bytes
    
    if RUBY_VERSION >= '1.9'
      if bytes
        header['Accept-Encoding']= "identity"
      end
    else
      header['Accept-Encoding']= 'gzip' if gzip
    end

    server = '' ; path = ''
    url.sub(/http:\/\/(.*?)(\/.*)/) { server = $1 ; path = $2 }
    
    begin
      http = Net::HTTP.new( server , 80 , @host, @port)
      http.start
      response , = http.get(path, header)
      case response.code
      when '304'  # Use Local Copy
        return([true, response])
      when '206'  # Partical Content
        if response.body[0] == 10
          return([true, response])  
        else 
          raise AboneExcepton
        end
      when '200'  # OK
        return([true, response])
      when '416'  # Requested Range Not Satisfiable
        raise AboneExcepton
      else
        return([false, response])
      end
    rescue AboneExcepton
      header.delete('Range')
      header.delete('If-Modified-Since')
      retry
    rescue StandardError,SignalException ,SocketError ,Resolv::ResolvError# とりあえず何か
      $stderr.puts "なにがしかのエラー"
      $stderr.puts "#{$!}"
      $stderr.puts "#{$@}"
      return ([false, response])
    ensure
      #http.finish if http
    end

  end

  def set_proxy( host , port )
    @host = host
    @port = port
  end

end
