# -*- coding: utf-8 -*-
require 'net/http'
require 'kconv'
require 'time'
require 'net2ch'
require 'fileutils'

class Thread_2ch
  include Net2ch
  
  def initialize( url , localfile = nil)
    server,board,thread = nil,nil,nil
    @url = url
    @url.sub(/http:\/\/(.*?)\/test\/read.cgi\/(.*)\/(.*)\//) {
      server = $1 ; board = $2 ; thread = $3
    }
    @url4dat = "http://#{server}/#{board}/dat/#{thread}.dat"

    FileUtils.mkdir_p "cache"
    if localfile
      @local_file = localfile
    else
      # 注意 serverはディレクトリを含む
      # @local_file = "cache/#{server.gsub('/','_')}_#{board}_#{thread}.dat"
      @local_file = "cache/#{board}_#{thread}.dat"
    end
    @last_gettime_file = @local_file + ".last"
    @title = nil
  end
  attr_reader :local_file
  
  def get_title
    if File.exist?(@local_file)
      open(@local_file,'r'){|d|
        if m = d.gets.to_s.match(/<>([^<]+)$/)
          m[1].toeuc
        else
          nil
        end
      }
    else
      nil
    end
  end

  def sync_cache
    start_byte_s = if File.exist?( @local_file ) and 
                       File.size(@local_file) > 1 then
                     st = File.size( @local_file ) - 1
                     "bytes=#{st}-"
                   else
                     false
                   end
    success , resp = Net2ch::get( @url4dat , 
                                  last_res_time_string,
                                  start_byte_s,
                                  false )
    if success 
      # puts "resp code=#{resp.code}"
      if resp["Last-Modified"]
        open(@last_gettime_file,'w'){|f| f.write resp["Last-Modified"] }
      else
        # puts "Last-Modifiedヘッダがない！".toutf8
      end
      
      if resp.code == "200"
        open(@local_file,'w'){|f| f.write resp.body }
      elsif resp.code == "206"
        open(@local_file,'a'){|f| f.write resp.body[1..-1] }
      end
    end
    return [success , resp.body.to_s]
  end
  
  def last_res_time_string
    if File.exist?( @last_gettime_file )
      File.read( @last_gettime_file )
    else
      nil
    end
  end

  def last_res_date
    if ts = last_res_time_string
      require 'time'
      Time.parse( ts )
    else
      nil
    end
  end
  
  def res_count
    if File.exist?(@local_file)
      File.read(@local_file).split(/\n/s).length
    else
      0
    end
  end

end # class Thread
